function initOverlay() {
  var menu = document.getElementById("contentAreaContextMenu");
  menu.addEventListener("popupshowing", contextPopupshowing, true);
}

function contextPopupshowing() {
  if(gContextMenu.onImage) {
        gContextMenu.showItem("context-firefusk", true);
  } else {
        if(gContextMenu.isTextSelected) {
            gContextMenu.showItem("context-firefusk", gContextMenu.isTextSelected);
        } else {
         gContextMenu.showItem("context-firefusk", gContextMenu.onSaveableLink);
        }
  }
  shown = getPref("shownAdvisory",2);
  if(shown != true) {
    document.getElementById("firefusk-item").setAttribute("label", "CLICK FOR INFO BEFORE USING");
    document.getElementById("firefusk-item").setAttribute("oncommand", "showAdvisory();"); 
  } else {
    document.getElementById("firefusk-item").setAttribute("label", getFilename(getLink()));
    document.getElementById("firefusk-item").setAttribute("oncommand", "firefusk('plus',20,'" + getLink() + "')"); 
  }
}

function showAdvisory() {
    alert("Welcome to the Firefusk v1.2!\n\n" +
            "Due to Firefusk's popularity, we've created a brand new site - " +
            "firefusk.com! Go there to view galleries created by users whenever they use Firefusk. If " +
            "you would rather not share with the community (it's anonymous!), uncheck the 'share' box " +
            "within the 'options' menu. \n\n" +
            "Extra warning!: Site contains adult content ('cause the internet is nothin' but pornography), " + 
            "and by sharing you are bound by the terms of use found at firefusk.com/tou");
    setPref("shownAdvisory", true, 2);
}

function populateMenu(menu, type, url) {
  
  if(url == "") {
        var cmd = "prepData";
  } else {
        var cmd = "firefusk";
  }

  var use = "10|20|50|100|200|500";

  var popup = menu.firstChild;
  
  while(popup.firstChild != null) {
    popup.removeChild(popup.firstChild);
  }
  
  use = use.split("|");
  var i;

  for(i = 0; i < use.length; i++) {
    var item = document.createElement("menuitem");
    item.setAttribute("label", use[i]);
    item.setAttribute("oncommand", cmd + "('" + type + "'," + use[i] + ",'" + url +  "'); event.preventBubble();");
    popup.appendChild(item);
  }
  
  item = document.createElement("menuitem");
  item.setAttribute("label","other");
  item.setAttribute("oncommand", cmd + "('" + type + "',prompt('how many?'),'" + url + "'); event.preventBubble();");
  popup.appendChild(item);
  
  menu.appendChild(popup);
}

function isImage(url) {
    var extension = getExtension(url);
    var imgExtensions = new Array(".jpg", ".jpeg", ".gif", ".png", ".bmp", ".tga", ".tif", ".tiff");
    var imgExtensions2 = new Array(".JPG", ".JPEG", ".GIF", ".PNG", ".BMP", ".TGA", ".TIF", ".TIFF");
    for(i=0;i < imgExtensions.length; i++) {
        if(imgExtensions[i] == extension) { return true; }
        if(imgExtensions2[i] == extension) { return true; }
    }
    return false;
}

function isVideo(url) {
    var extension = getExtension(url);
    var videoExtensions = new Array(".wmv", ".mpg", ".avi", ".mpeg", ".asf", ".m4v", ".mp4", ".mp4v", ".mov", ".rm", ".3g2");
    var videoExtensions2 = new Array(".WMV", ".MPG", ".AVI", ".MPEG", ".ASF", ".M4V", ".MP4", ".MP4V", ".MOV", ".RM", ".3G2");
    for(i=0;i < videoExtensions.length; i++) {
        if(videoExtensions[i] == extension) { return true; }
        if(videoExtensions2[i] == extension) { return true; }
    }
    return false;
}

function isInt(q) {
    switch(q) {
        case '0' : return true;
        case '1' : return true;
        case '2' : return true;
        case '3' : return true;
        case '4' : return true;
        case '5' : return true;
        case '6' : return true;
        case '7' : return true;
        case '8' : return true;
        case '9' : return true;
    }
    
    return false;
}

function findDigits(q) {
    var numDigits = 0;
    for(i = q.length - 1; i >= 0; i--) {
        if( isInt(q[i]) )
            numDigits++;
        else
            return numDigits;
    }
    return numDigits;
}

function getLink() {
    var url = null;
    if(gContextMenu.isTextSelected) {
        url = gContextMenu.searchSelected();
    } else {
        if(gContextMenu.onImage) {
            url = gContextMenu.imageURL;
        }
        if(gContextMenu.onSaveableLink) {
            link = 'getLinkURL' in gContextMenu ? gContextMenu.getLinkURL() : gContextMenu.linkURL();
            if(isImage(link) || isVideo(link)) {
                url = link;
            }
        }
    }
    return url;
}

function prepData(type, span, url) {
    var url = getLink();
    firefusk(type, span, url);
}

function ffManual(url) {
    if(url == null) {
        url = getLink();
    }
    url = prompt("enter single url for normal display, or for firefusk in format 'http://www.domain.com/img[01-20].jpg'",url);
    if(url.indexOf("[") != -1) {
        firefusk(null,null,url);
        return;
    }
    var newDiv = _content.document.createElement("div");
    newDiv.id = "ffImage";
    newDiv.style.border = "solid 1px #ccc";
    newDiv.style.margin = "7px";
    newDiv.style.textAlign = "center";
    newDiv.style.position = "absolute";
    newDiv.style.backgroundColor = "#fff";
    newDiv.style.padding = "3px";
    newDiv.style.fontFamily = "helvetica, arial, sans-serif";
    newDiv.style.fontSize = "12px";
    
    var closeBox = _content.document.createElement("div");
    closeBox.style.textAlign = "right";
    closeBox.style.margin = "0px";
    closeBox.style.padding = "0px";
    closeBox.style.backgroundColor = "#eee";
    closeBox.style.marginBottom = "7px;"
    closeBox.innerHTML = "<div style='float:left; margin-left: 1px; margin-top: 1px; text-align: left; width: 100px;'>Firefusk</div><a href='#' style='text-decoration: none; color: #999' onclick='this.parentNode.parentNode.parentNode.removeChild(this.parentNode.parentNode); return false;'>close</a>";
    newDiv.appendChild(closeBox);
    
    var newImg = _content.document.createElement("img");
    if(url.substring(0, 7) == "http://") {
        newImg.src = url;
    } else {
        newImg.src = "http://" + url;
    }
    
    newImg.style.margin = "auto";
    newImg.style.marginBottom = "4px";
    newDiv.appendChild(newImg);
    var temp = (window.innerHeight / 2) - (newImg.height) - 100;
    if(temp < 1) {
        newDiv.style.top = 0;
    } else {
        newDiv.style.top = temp;
    }
    temp = (window.innerWidth / 2) - (newImg.width) - 30;
    if(temp < 1) {
        newDiv.style.top = 0;
    } else {
        newDiv.style.left = temp;
    }
    newDiv.innerHTML = newDiv.innerHTML + "<br>" + url;

    _content.document.body.appendChild(newDiv);
    _content.document.location.href = _content.document.location.href + "#";
}

function getUrls(type, span, url) {
    var trueURL = url;
    var fromEnd = 0;
    var numDigits = 0;
    var extension = url.substring(url.lastIndexOf("."));
    var path = url.substring(0, url.lastIndexOf("/") + 1);
    url = url.substring(url.lastIndexOf("/") + 1, url.lastIndexOf("."));
    var tempURL = url;
    while(numDigits < 1 && tempURL.length > 0) {
        fromEnd++;
        numDigits = findDigits(tempURL);
        tempURL = tempURL.substr(0, tempURL.length - 1);
    }
    
    if(numDigits == 0) {
        var srcs = new Array(1);
        srcs[0] = trueURL;
        return srcs; 
    }

    var engine = url.substring(0, url.length - fromEnd - numDigits + 1);
    var caboose = url.substring(url.length - fromEnd + 1);
    var digits = url.substring(url.length - fromEnd - numDigits + 1, url.length - fromEnd + 1);        
        
    var alpha, zed;
    
    switch(type) {
        case "plus" : 
            alpha = parseInt(digits, 10);
            zed = alpha + span;
            break;
        case "minus" : 
            zed = parseInt(digits, 10);
            alpha = zed - span;
            break;
        case "plusminus" : 
            alpha = parseInt(digits, 10) - span;
            zed = parseInt(digits, 10) + span;
            break;
    }
    
    if(alpha < 0) alpha = 0;
    var srcs = new Array(zed - alpha);
    var counter = 0;
    
    leading = document.getElementById("firefusk-leading").getAttribute("checked");

    for(i = alpha; i < zed + 1; i++) {
        var j = i.toString();
        while((j.length < numDigits) && leading) {
            j = "0" + j;
        }
        srcs[counter] = path + engine + j + caboose + extension;
        counter++;
    }
    
    return srcs;
}

function getFilename(url) {
    return url.substring(url.lastIndexOf("/") + 1);
}


function getPath(url) {
    return url.substring(0, url.lastIndexOf("/") + 1);
}

function getFromBrackets(url) {
    var srcGroup = new Array();
    var srcList = new Array();
    var openbracketpos = url.indexOf('[');
    if(openbracketpos != -1) {
        var closebracketpos = url.indexOf(']');
        var firstChunk = url.substring(0, openbracketpos);
        var tempChunk = url.substring(openbracketpos + 1, closebracketpos);
        firstNum = tempChunk.substring(0, tempChunk.indexOf('-'));
        var secondNum = tempChunk.substring(tempChunk.indexOf('-') + 1);
        var span = parseInt(secondNum, 10) - parseInt(firstNum, 10);
        var endChunk = url.substring(closebracketpos + 1);
        var newUrl = firstChunk + firstNum + endChunk;
        var type = "plus"
        
        if(newUrl.indexOf('[') != -1) {
            if(firstNum > secondNum) {
                var temp = firstNum;
                secondNum = firstNum;
                firstNum = temp;
                span = 0 - span;
            }

            var start = parseInt(firstNum, 10);
            for(var j = 0; j <= span; j++) {
                var stri = start + j;
                while(stri.length < firstNum.length) {
                    stri = "0" + stri;
                }
                newUrl = firstChunk + stri + endChunk;
               
                srcList = srcList.concat(getFromBrackets(newUrl));
            }
        } else {
            if(parseInt(span, 10) < 0) {
                type = "minus";
                span = 0 - span;
            }
            
            srcList[0] = getUrls(type, span, newUrl);
        }
   }
   return srcList;
}

function getExtension(url) {
    return url.substring(url.lastIndexOf("."));
}

function firefusk(type, span, url) {
    var trackingInfo = new Array();
    span = parseInt(span, 10);
    var urlList = new Array();
    var srcList = new Array();
    
    if(url.indexOf('[') != -1) {
        srcList = getFromBrackets(url);
        for(i=0;i < srcList.length; i++) {
            trackingInfo[i] = new Array("plus", srcList[i].length, srcList[i][0]);
        }
    } else {
        trackingInfo[0] = new Array(type, span, url);
        srcList[0] = getUrls(type, span, url);
    }
    
    var path = url.substring(0, url.lastIndexOf("/") + 1);
    
    var tab = document.getElementById("firefusk-tab").getAttribute("checked");
    if(tab) {
        var ffTab = gBrowser.addTab("about:blank");
        //gBrowser.selectedTab = ffTab;
        var ffBrowser = gBrowser.getBrowserForTab(ffTab);
        var ffTarget = ffBrowser.contentWindow;
    } else {
        var ffTarget = window.open("about:blank");
    }
    
    ffTarget.document.writeln("<html>");
    ffTarget.document.writeln("<head>");
    ffTarget.document.writeln("<title>firefusk: " + url + "</title>");
    ffTarget.document.writeln("<style> .error { display: none; } </style>");
    ffTarget.document.writeln("<style>");
    ffTarget.document.writeln("body { font-family: helvetica, verdana; text-align: center; font-size: 12px;}");
    ffTarget.document.writeln("a, a:hover, a:visited { color: #b33c04; text-decoration: none; } ");
    ffTarget.document.writeln(".wrap { text-align: center; float: left; padding: 3px; border: 1px solid #ccc; margin: 7px; }");
    ffTarget.document.writeln("img { margin: auto; border: 0px}");
    ffTarget.document.writeln(".wrap img { margin-bottom: 4px; }"); 
    ffTarget.document.writeln("</style>");
    ffTarget.document.writeln("<script>");
    ffTarget.document.writeln("function change() {");
    ffTarget.document.writeln("    document.styleSheets[0].disabled = !document.styleSheets[0].disabled;");
    ffTarget.document.writeln("}");
    ffTarget.document.writeln("</script>");
    ffTarget.document.writeln("</head>");
    ffTarget.document.writeln("<body>");
    ffTarget.document.writeln("<div id='all'>");
    ffTarget.document.writeln("<img alt='firefusk' src='chrome://firefusk/content/logo.gif' />");
    ffTarget.document.writeln("<p><a href='javascript:change()'>toggle broken links</a></p>");
    
    track = document.getElementById("firefusk-track").getAttribute("checked");
    waitList = srcList.length
    for(var i = 0; i < srcList.length; i++) {
        writeSrcs(ffTarget, srcList[i]);
        if(track) {
            ffTarget.document.writeln("<img onload='this.parentNode.removeChild(this)' src='http://www.firefusk.com/track/callcall.gif?m=" + trackingInfo[i][0] + "&a=" + trackingInfo[i][1] + "&u=" + trackingInfo[i][2] + "'>"); 
        }
    }
        
    if(!working) {
        ffTarget.document.writeln("</div");
        ffTarget.document.writeln("</body>");
        ffTarget.document.writeln("</html>");    
        ffTarget.document.close();
    }
    
    putInstance(url, "recent");
}



function doVideo(ffTarget, srcs) {
        waitList--;
        if(working) {
            waitList++;
            setTimeout( doVideo,  Math.round(Math.random()*2000), ffTarget, srcs ); 
            return;
        }
        ffTarget.document.writeln("<p style='clear:both'><a href='" + srcs[0] + "'>video link</a></p>");
        ffTarget.document.writeln("<p>" + srcs[0] + " - " + getFilename(srcs[srcs.length - 1]) + "</p>");            
        working = true;
        activeCons = srcs.length;
        for(i = 0; i < srcs.length; i++) {
            startTry(ffTarget, srcs[i]);
        }
}

function writeSrcs(ffTarget, srcs) {

        if(isVideo(srcs[0])) { 
            doVideo(ffTarget, srcs);
        } else { 
            ffTarget.document.writeln("<p style='clear:both'><a href='" + srcs[0] + "'>image link</a></p>");
            ffTarget.document.writeln("<p>" + srcs[0] + " - " + getFilename(srcs[srcs.length - 1]) + "</p>");
            working = false;
            for(i = 0; i < srcs.length; i++) {
                    writeImg(ffTarget, srcs[i]);
            } 
        }
}

function writeImg(ffTarget, src) {
        ffTarget.document.writeln("<div class='wrap'>");
        ffTarget.document.writeln("<img onerror='this.parentNode.className=\"wrap error\"; this.parentNode.removeChild(this);' alt='" + src + "' src='" + src + "' alt='" + src + "' /><br />");
        ffTarget.document.writeln("<span>" + src + "</span>");
        ffTarget.document.writeln("</div>");
}

function writeVid(ffTarget, src, image) {
        ffTarget.document.writeln("<div class='wrap'>");
        ffTarget.document.writeln("<a href='" + src + "'>");
        ffTarget.document.writeln("<img alt='" + src + "' src='chrome://firefusk/content/" + image + ".gif' /><br />");
        ffTarget.document.writeln("</a>");
        ffTarget.document.writeln("<span>" + src + "</span>");
        ffTarget.document.writeln("</div>");
}

function populateInstance(source) {
  var use = getInstances(source);

  var theMenu = document.getElementById("firefusk-" + source);
  
  var popup = theMenu.firstChild;
  
  while(popup.firstChild != null) {
    popup.removeChild(popup.firstChild);
  }
   
  if(use != null) {
    for(i = 0; i < use.length; i++) {
        var subitem = document.createElement("menuitem");

        subitem.setAttribute("label", use[i]);
        subitem.setAttribute("oncommand", "ffManual('" + use[i] + "')");

        popup.appendChild(subitem);
    }
    var clearitem = document.createElement("menuitem");
    clearitem.setAttribute("label", "clear");
    clearitem.setAttribute("oncommand", "clearInstances('" + source + "')");
    popup.appendChild(clearitem);
  }
  
  if(source == 'saved') {
    var newsub = document.createElement("menuitem");
    newsub.setAttribute("label", "save");
    newsub.setAttribute("oncommand", "saveIt()");
    popup.appendChild(newsub);
  }
  
  theMenu.appendChild(popup);
}

function saveIt() {
    url = getLink();
    putInstance(url, "saved");
}

// destination - either saved or recent
function putInstance(q, destination) {
    try {
        var kept = getInstances(destination, 0);
        
        newKept = q;
        while(kept.length > 20) {
            kept.pop();
        }
        
        if(kept != null) {
          for(i = 0; i < kept.length; i++) {
                if(kept[i] == q) return; 
                newKept = newKept + "|%|" + kept[i];
            }
        }
        
    } catch(e) {
        newKept = q;
    }

    setPref(destination, newKept,  0);
}

function clearInstances(source) {
    setPref(source, null, 0);
}

function getInstances(source) {
    try {
        var kept = getPref(source, 0);
        kept = kept.split("|%|");
    } catch(e) {
        kept = null;
    }
    
    return kept;
}

function removeInstance(q, destination) {
    try {
        var kept = getInstances(destination, 0);
        
        if(kept != null) {
        
          if(kept[0] != q) {
            newKept = kept[0];
            if(kept[1] != q) {
                newKept = newKept + "|%|" + kept[1];
            }
          } else {
            newKept = kept[1];
          }
        
          for(i = 2; i < kept.length; i++) {
                if(kept[i] != q) newKept = newKept + "|%|" + kept[i];
            }
        }
        
    } catch(e) {
        newKept = null;
    }
    if(newKept == "") newKept = null;
    setPref(destination, newKept,  0);
}

function setPref(name, value, type) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    
    name = "extensions.firefusk." + name;
    
    if(value == null) {
        try {
           prefs.clearUserPref(name);
        } catch(e) {}
    } else {
        switch(type) {
            case 0: prefs.setCharPref(name, value); break;
            case 1: prefs.setIntPref(name, value); break;
            case 2: prefs.setBoolPref(name, value); break;
        }
    }
}

function getPref(name, type) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    
    name = "extensions.firefusk." + name;
    try {
         switch(type) {
            case 0: return prefs.getCharPref(name);
            case 1: return prefs.getIntPref(name); 
            case 2: return prefs.getBoolPref(name);
          }
    } catch(e) {
        return null;
    }    
}

// AJAX

var req = new Array();
var working;
var activeCons = 0;
var waitList = 0;

function startTry(ffTarget, src) {
	var num = req.length;
	req[num] = false;
    // branch for native XMLHttpRequest object
    if(window.XMLHttpRequest) {
    	try {
			req[num] = new XMLHttpRequest();
        } catch(e) {
			req[num] = false;
        }
    // branch for IE/Windows ActiveX version
    } else if(window.ActiveXObject) {
       	try {
        	req[num] = new ActiveXObject("Msxml2.XMLHTTP");
      	} catch(e) {
        	try {
          		req[num] = new ActiveXObject("Microsoft.XMLHTTP");
        	} catch(e) {
          		req[num] = false;
        	}
		}
    }
	if(req[num]) {
		req[num].onreadystatechange = function () { processReqChange(ffTarget, src, num) };
		req[num].open("HEAD", src, true);
		req[num].send("");
	}
}

function processReqChange(ffTarget, src, num) {
    // only if req shows "loaded"
    if (req[num].readyState == 4) {
        // only if "OK"
        activeCons--;
        if (req[num].status == 200) {
            if(req[num].getResponseHeader("Content-Type").indexOf("video") != "-1") {
                writeVid(ffTarget, src, 'video');
            } else {
                // was 'notsure', but im sure (heh heh) that most of these that aren't
                // webpages are .wmv being served incorrectly...
                if(req[num].getResponseHeader("Content-Type") != "text/html") {                
                    writeVid(ffTarget, src, 'video');
                }
            }
        }
        if(activeCons == 0) {
            working = false;
            if(waitList == 0) {
                ffTarget.document.writeln("</div");
                ffTarget.document.writeln("</body>");
                ffTarget.document.writeln("</html>");
                ffTarget.document.close();
            }
            req = new Array();
        }
    }
}

// AJAX




// OPTIONS

function initOptions() {

}

function saveOptions() {

}

window.addEventListener("load", initOverlay, false);